Imports System
Imports System.IO.Ports
Imports System.Threading
Imports System.IO
Imports System.String
Imports Microsoft.VisualBasic

Public Class Form1

    Delegate Sub SetTextCallback(ByVal [text] As String)
    Dim scansione_ingressi As Integer = 1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Try
            Me.LinkLabel4().Links.Add(0, 28, "http://www.progetti-hw-sw.it")

            ' Vedo quali sono le seriali disponibili:
            Dim s As String = "COM1"
            For Each s In SerialPort.GetPortNames()
                ComboBox_porte_seriali.Items.Add(s)
            Next s
            ComboBox_porte_seriali.Text = s

            SerialPort1.PortName = s

            ' Allow the user to set the appropriate properties.
            SerialPort1.BaudRate = 115200
            SerialPort1.Parity = Parity.None
            SerialPort1.DataBits = 8
            SerialPort1.StopBits = StopBits.One
            SerialPort1.Handshake = Handshake.None

            ' Set the read/write timeouts
            SerialPort1.ReadTimeout = 500
            SerialPort1.WriteTimeout = 500

        Catch ex As Exception
            MessageBox.Show("Impossibile eseguire il programma, verificare l'installazione del Framework sul PC, contattare studio_progett_elett@virgilio.it")
        End Try
    End Sub

    Private Function ToHex(ByVal stringa As String) As Int32
        
        If stringa = "0" Then Return 0
        If stringa = "1" Then Return 1
        If stringa = "2" Then Return 2
        If stringa = "3" Then Return 3
        If stringa = "4" Then Return 4
        If stringa = "5" Then Return 5
        If stringa = "6" Then Return 6
        If stringa = "7" Then Return 7
        If stringa = "8" Then Return 8
        If stringa = "9" Then Return 9
        If stringa.ToUpper = "A" Then Return 10
        If stringa.ToUpper = "B" Then Return 11
        If stringa.ToUpper = "C" Then Return 12
        If stringa.ToUpper = "D" Then Return 13
        If stringa.ToUpper = "E" Then Return 14
        If stringa.ToUpper = "F" Then Return 15

    End Function

    Private Sub Btn_invia_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_invia.Click
        On Error Resume Next
        Dim stringa_appoggio As String
        
        Dim prova As Int32
        If Len(TxtSend.Text) = 7 Then
            stringa_appoggio = Microsoft.VisualBasic.Right(TxtSend.Text, 6)

            If (Not (IsNumeric(stringa_appoggio))) And (TxtSend.Text.Substring(0, 1) = "?") Then
                MessageBox.Show("Occorre inviare un numero compreso tra 000000 e 999999")
            Else
                Lbl_atteso.Text = Str((CLng(stringa_appoggio) Xor &HB631D5) Mod 1000000)

                prova = ToHex(TextBox1.Text.Substring(0, 1)) * 1048576
                prova = ToHex(TextBox1.Text.Substring(1, 1)) * 65536 + prova
                prova = ToHex(TextBox1.Text.Substring(2, 1)) * 4096 + prova
                prova = ToHex(TextBox1.Text.Substring(3, 1)) * 256 + prova
                prova = ToHex(TextBox1.Text.Substring(4, 1)) * 16 + prova
                prova = ToHex(TextBox1.Text.Substring(5, 1)) + prova

                Lbl_atteso.Text = Str((CLng(stringa_appoggio) Xor prova) Mod 1000000)

                If SerialPort1.IsOpen Then
                    SerialPort1.Write(TxtSend.Text)
                Else
                    MessageBox.Show("Prima di inviare un comando occorre aprire la comunicazione seriale")
                End If

            End If
        Else
            MessageBox.Show("Occorre inviare 7 caratteri, il primo carattere  il comando, ad esempio ?123456 ")
        End If
    End Sub

    Private Sub BtnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnStart.Click
        If SerialPort1.IsOpen Then
            Application.DoEvents()
            SerialPort1.Close()
            Application.DoEvents()
        End If

        Try
            SerialPort1.Open()

            Btn_invia.Enabled = True
            BtnStop.Enabled = True
            Btn_bootloader.Enabled = True
            Btn_leggi_num_riavvii.Enabled = True
            Btn_cambio_PW.Enabled = True
            Btn_azzera_num_riavvii.Enabled = True
            Btn_reset_password.Enabled = True

            BtnStart.Enabled = False

        Catch ex As Exception
            MessageBox.Show("Impossibile aprire porta seriale " & ex.ToString)
        End Try

    End Sub

    Private Sub BtnStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnStop.Click
        On Error Resume Next

        Btn_invia.Enabled = False
        BtnStop.Enabled = False
        Btn_bootloader.Enabled = False
        Btn_leggi_num_riavvii.Enabled = False
        Btn_cambio_PW.Enabled = False
        Btn_azzera_num_riavvii.Enabled = False
        Btn_reset_password.Enabled = False

        BtnStart.Enabled = True

        SerialPort1.Close()

    End Sub


    Private Sub SerialPort1_DataReceived(ByVal sender As Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived
        Try
            Dim ricevuto As String
            ricevuto = SerialPort1.ReadExisting
            SetText(ricevuto)
        Catch ex As Exception
        End Try
    End Sub

    Private Sub SetText(ByVal [text] As String)
        ' InvokeRequired required compares the thread ID of the
        ' calling thread to the thread ID of the creating thread.
        ' If these threads are different, it returns true.
        If Me.TxtRicevuto.InvokeRequired Then
            Dim d As New SetTextCallback(AddressOf SetText)
            Me.Invoke(d, New Object() {[text]})
        Else
            Me.TxtRicevuto.Text = [text]
        End If

    End Sub


    Private Sub Btn_bootloader_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_bootloader.Click
        MessageBox.Show("Attenzione, inviando i caratteri >abcdef la scheda va in bootloader ed e' possibile aggiornare il firmware della scheda. Si consiglia di NON eseguire questo comando")
    End Sub

    Private Sub Btn_leggi_num_riavvii_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_leggi_num_riavvii.Click
        If SerialPort1.IsOpen Then
            TxtSend.Text = "Nabcdef"
            SerialPort1.Write(TxtSend.Text)
        End If
    End Sub

    Private Sub Btn_azzera_num_riavvii_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_azzera_num_riavvii.Click
        If SerialPort1.IsOpen Then
            MessageBox.Show("Attenzione, questo comando funziona solo se, preventivamente, e' stato inviato il comando di autenticazione con la password che  Pxxxxxx dove xxxxxx e' la password scelta")
            TxtSend.Text = "Labcdef"
            SerialPort1.Write(TxtSend.Text)
        End If
    End Sub

    Private Sub Btn_cambio_PW_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_cambio_PW.Click
        If SerialPort1.IsOpen Then
            MessageBox.Show("Attenzione, questo comando funziona solo se, preventivamente, e' stato inviato il comando di autenticazione con la password che  Pxxxxxx dove xxxxxx e' la password scelta")

            If Len(TxtCambio_PW.Text) = 6 Then
                SerialPort1.Write("h" + TxtCambio_PW.Text)
            Else
                MessageBox.Show("Occorre inserire una password di 6 caratteri esadecimali, ad esempio B631D5 ")
            End If

        End If
    End Sub

    Private Sub Btn_reset_password_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_reset_password.Click
        If SerialPort1.IsOpen Then
            TxtSend.Text = "Zabcdef"
            SerialPort1.Write(TxtSend.Text)
        End If
    End Sub
End Class
